Attribute VB_Name = "Global"
Public Declare Function MoveWindow Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByVal X As Long, _
     ByVal Y As Long, _
     ByVal nWidth As Long, _
     ByVal nHeight As Long, _
     ByVal bRepaint As Long) As Long

Public Declare Function ShowWindow Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByVal nCmdShow As Long) As Long
Public Const SW_SHOW = 5
Public Const SW_HIDE = 0

Private Const LF_FACESIZE = 32
Public Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(1 To LF_FACESIZE) As Byte
End Type
Public Declare Function CreateFontIndirect Lib "gdi32.dll" Alias "CreateFontIndirectA" ( _
     ByRef lpLogFont As LOGFONT) As Long

Public Declare Function SelectObject Lib "gdi32.dll" ( _
     ByVal hdc As Long, _
     ByVal hObject As Long) As Long
Public Declare Function GetDC Lib "user32.dll" ( _
     ByVal hwnd As Long) As Long

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
     ByRef Destination As Any, _
     ByRef Source As Any, _
     ByVal Length As Long)

Public Declare Function GetCharWidth32 Lib "gdi32.dll" Alias "GetCharWidth32A" ( _
     ByVal hdc As Long, _
     ByVal iFirstChar As Long, _
     ByVal iLastChar As Long, _
     ByRef lpBuffer As Long) As Long

'Public Type SIZEL
'    cx As Long
'    cy As Long
'End Type
Private Type Size
    cx As Long
    cy As Long
End Type
Private Declare Function GetTextExtentPoint32 Lib "gdi32.dll" Alias "GetTextExtentPoint32A" ( _
     ByVal hdc As Long, _
     ByVal lpsz As String, _
     ByVal cbString As Long, _
     ByRef lpSize As Size) As Long

Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" ( _
     ByVal hwnd As Long, _
     ByVal wMsg As Long, _
     ByVal wParam As Long, _
     ByRef lParam As Any) As Long

Public Declare Function ReleaseDC Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByVal hdc As Long) As Long

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Declare Function GetWindowRect Lib "user32.dll" ( _
     ByVal hwnd As Long, _
     ByRef lpRect As RECT) As Long


Public Function HiWord(DWord As Long) As Integer
    HiWord = (DWord And &HFFFF0000) \ &H10000
End Function

Public Function LoWord(DWord As Long) As Integer
    LoWord = IIf(DWord And &H8000&, DWord Or &HFFFF0000, DWord And &HFFFF&)
End Function

Public Function MakLng(X As Integer, Y As Integer) As Long
    MakLng = X + (Y * &H10000)
End Function

Public Function FontInfo(ByVal hCtlWnd As Long)
 Dim VarFontInfo As LOGFONT, hFont As Long
 hFont = CreateFontIndirect(VarFontInfo)
 hCtlDc = GetDC(hCtlWnd)
 Dim hFont2 As Long
 hFont2 = SelectObject(hCtlDc, hFont)
 CopyMemory VarFontInfo, ByVal hFont, Len(VarFontInfo)
 MsgBox VarFontInfo.lfHeight
End Function

Public Function FontWidth(ByVal hCtlWnd As Long, ByVal StrLen As Long) As Long
 Dim hCtlDc As Long, VarFontWidth As Long
 hCtlDc = GetDC(hCtlWnd)
 MsgBox GetCharWidth32(hCtlDc, 1, StrLen - 1, VarFontWidth)
 MsgBox VarFontWidth
End Function


Public Function GetTextSize(ByVal hwnd As Long, strText As String, Optional ByVal HeightTrue As Boolean = False) As Long
   Dim hdc As Long, hFont As Long, sz As Size

  hdc = GetDC(hwnd)                               'get handle for proper device context
    Const WM_GETFONT = &H31
    hFont = SendMessage(hwnd, WM_GETFONT, 0, 0)  'must select hWnd's font into DC,
    hFont = SelectObject(hdc, hFont)              'otherwise System font is used..
    GetTextExtentPoint32 hdc, strText, Len(strText), sz   'get text width/height
    SelectObject hdc, hFont                       'select original font back
  ReleaseDC hwnd, hdc                             'and release DC

  If HeightTrue Then GetTextSize = sz.cy Else GetTextSize = sz.cx

End Function

